//	Guide_Box.js
//	http://www.pictrix.jp/	Umezawa
//	05.2.19	7:54 PM


ptObj = new Array();
ptCnt = 0;

function gp( xObj )
{
	if( xObj.typename == "GroupItem" ){

		var gnObj = xObj.groupItems;
		var j;

		if ( gnObj.length > 0 ){

			for ( var g = 0; g < gnObj.length; g++ ) gp( gnObj[ g ] );
		}

		gObj = xObj.pathItems;
		for ( j = 0; j < gObj.length; j++ ) ptObj[ ptCnt++ ] = gObj[ j ] ;
		gObj = xObj.textFrames;
		for ( j = 0; j < gObj.length; j++ ) ptObj[ ptCnt++ ] = gObj[ j ] ;
		gObj = xObj.placedItems;
		for ( j = 0; j < gObj.length; j++ ) ptObj[ ptCnt++ ] = gObj[ j ] ;
		gObj = xObj.rasterItems;
		for ( j = 0; j < gObj.length; j++ ) ptObj[ ptCnt++ ] = gObj[ j ] ;
		gObj = xObj.meshItems;
		for ( j = 0; j < gObj.length; j++ ) ptObj[ ptCnt++ ] = gObj[ j ] ;
		gObj = xObj.pluginItems;
		for ( j = 0; j < gObj.length; j++ ) ptObj[ ptCnt++ ] = gObj[ j ] ;
		gObj = xObj.graphItems;
		for ( j = 0; j < gObj.length; j++ ) ptObj[ ptCnt++ ] = gObj[ j ] ;
	}

	else{

		ptObj[ ptCnt++ ] =  xObj;
	}
}

if (documents.length > 0 && activeDocument.pathItems.length > 0){

	inp = prompt( "Axis [ x / -x / y / -y / cx / cy ]" , "");

	if ( inp != null && inp != "" ){

		if ( inp == "-x" || inp == "-X" ) axis = 0;
		else if ( inp == "+y" || inp == "+Y" || inp == "y" || inp == "Y" ) axis = 1;
		else if ( inp == "+x" || inp == "+X" || inp == "x" || inp == "X" ) axis = 2;
		else if ( inp == "-y" || inp == "-Y" ) axis = 3;
		else if ( inp == "cx" || inp == "CX" ) axis = 4;
		else if ( inp == "cy" || inp == "CY" ) axis = 5;
		else axis = -1;

		if ( axis == -1 ) alert( "Input error" );

		else{

			SelObj = activeDocument.selection;

			for ( i = 0; i < SelObj.length; i++ ) gp( SelObj[ i ] );

			for ( k =0; k < ptCnt; k++ ){

				bx = ptObj[ k ].geometricBounds;
				switch ( axis ){
					case 0 : guideGen( bx[ 0 ], 0 ); break;
					case 2 : guideGen( bx[ 2 ], 0 ); break;
					case 1 : guideGen( bx[ 1 ], 1 ); break;
					case 3 : guideGen( bx[ 3 ], 1 ); break;
					case 4 : 
						wk = ( bx[ 0 ] + bx[ 2 ] ) * 0.5;
						guideGen( wk, 0 ); break;
					case 5 : 
						wk = ( bx[ 1 ] + bx[ 3 ] ) * 0.5;
						guideGen( wk, 1 ); break;
				}
			}
		}
	}
}



function guideGen( p, sw)
{
	var pos = new Array( 2 );

	if ( sw == 0 ){
		pos[ 0 ] = [ p, 7000.0 ];
		pos[ 1 ] = [ p, -7000 ];
	}
	else{
		pos[ 0 ] = [ -7000.0, p ];
		pos[ 1 ] = [ 7000.0, p ];
	}
	var line = activeDocument.activeLayer.pathItems.add();

	line.stroked	= true;
	line.filled	= false;
	line.guides	= true;
	line.setEntirePath( pos );
}


